<?php
echo <<<'START'
********************************************************************************
  ____  __  ____        _____     ________    __________ _______     ________ 
 |    |/ _||    |      /  _  \    \_____  \   \______   \\      \   /  _____/ 
 |      <  |    |     /  /_\  \    /  ____/    |     ___//   |   \ /   \  ___ 
 |    |  \ |    |___ /    |    \  /       \    |    |   /    |    \\    \_\  \
 |____|__ \|_______ \\____|__  /  \_______ \   |____|   \____|__  / \______  /
         \/        \/        \/           \/                    \/         \/
  
   Lossless Converter from ArtStudio .ART to Portable Network Graphics .PNG
                               by TheTom/SAMAR           v 1.0

********************************************************************************
START;

// Website: http://tomseditor.com/gallery
// Github : https://github.com/TomsEditor
// License: MIT

@mkdir('png');

foreach (glob('kla/*.{koa,kla}', GLOB_BRACE) AS $inName)
{
	$outName = 'png/' . pathinfo($inName, PATHINFO_FILENAME) . '.png';

	$res = kla2png($inName, $outName, $error);
	if (!$res)
	{
		echo basename($inName) . ': ' . $error . "\r\n";
	}
}

function kla2png($inName, $outName, &$error)
{
	$file = file_get_contents($inName);

	if (strlen($file) < 10003 or strlen($file) > 10100)
	{
		$error = 'Input file is not a valid .KLA';
		return 0;
	}

	$pixels  = substr($file, 2, 8000);
	$palette1 = substr($file, 8002, 1000);
	$palette2 = substr($file, 9002, 1000);
	$bgColor = ord($file[10002]);

	$im = imagecreatetruecolor(320, 200);

	$pepto = array(0,16777215,6829867,7382194,7290246,5803331,3483769,12109679,
			7294757,4405504,10119001,4473924,7105644,10146436,7102133,9803157);

	$p = 0;
	$c = 0;
	$colors = array();

	for ($y=0; $y<ceil(200/8); $y++)
	{
		for ($x=0; $x<ceil(320/8); $x++)
		{
			$colors[0] = $bgColor;
			$colors[1] = (ord($palette1[$c]) >> 4) & 15;
			$colors[2] = ord($palette1[$c]) & 15;
			$colors[3] = ord($palette2[$c]) & 15;

			$c++;

			for ($j=0; $j<8; $j++)
			{
				$byte = ord($pixels[$p++]);

				for ($i=0; $i<8; $i+=2)
				{
					$index = ($byte >> (6-$i)) & 3;

					$rgb = $pepto[$colors[$index]];
					
					imagesetpixel($im, 8*$x + $i   , 8*$y + $j, $rgb);
					imagesetpixel($im, 8*$x + $i +1, 8*$y + $j, $rgb);
				}
			}
		}
	}

	imagepng($im, $outName);
	return 1;
}